<template>
  <div class="container">
    <h1 v-if="imageName">{{ imageName }}</h1>
    <h1 v-else>Определение породы по изображению</h1>
    <br><br>
    <picture-input
      ref="pictureInput"
      @change="onChange"
      @remove="onRemove"
      width="600"
      height="600"
      margin="16"
      accept="image/jpeg,image/png"
      size="10"
      :z-index=1
      :removable="true"
      :customStrings="{
        change: 'Загрузить фото',
        remove: 'Убрать фото',
        drag: 'Нажмите, чтобы загрузить фото <br> 😺 <br> или просто перетащите его'
      }">
    </picture-input>
    <br>
    <transition name="fade">
      <a v-if="showPredictButton" v-on:click="callPredict" class="btn btn-warning">
        Определить породу
      </a>
    </transition>
    <slideout-panel></slideout-panel>
  </div>
</template>

<script>
import Vue from 'vue';
import PictureInput from 'vue-picture-input';
import Prediction from '@/components/Prediction';
import VueSlideoutPanel from 'vue2-slideout-panel';
import axios from 'axios';

Vue.use(VueSlideoutPanel);
Vue.component('prediction', Prediction);

export default {
  name: 'imageLoad',
  data() {
    return {
      showPredictButton: false,
      imageName: '',
      imageFile: '',
    };
  },
  components: {
    PictureInput,
    Prediction,
  },
  methods: {
    onChange() {
      this.showPredictButton = true;
      this.imageName = this.$refs.pictureInput.fileName;
      this.imageFile = this.$refs.pictureInput.image;
    },
    onRemove() {
      this.showPredictButton = false;
      this.imageName = '';
    },
    callPredict() {
      const path = 'http://localhost:5000/predict';
      axios.post(path, { image_bs64: this.imageFile })
        .then((res) => {
          this.$showPanel({
            component: 'prediction',
            openOn: 'bottom',
            height: 500,
            props: {
              breeds: Object.keys(res.data),
              predictionValues: Object.values(res.data),
            },
          });
        });
    },
  },
};
</script>

<style>
  #app {
    font-family: 'Avenir', Helvetica, Arial, sans-serif;
    -webkit-font-smoothing: antialiased;
    -moz-osx-font-smoothing: grayscale;
    text-align: center;
    color: #2c3e50;
    margin-top: 60px;
  }

  h1, h2 {
    font-weight: normal;
  }

  ul {
    list-style-type: none;
    padding: 0;
  }

  li {
    display: inline-block;
    margin: 0 10px;
  }

  a {
    color: #42b983;
  }
</style>
